includeLibrary("/OpenForum/Javascript/ui.js");
includeInitFunction( "initialiseLists();" )

var groups = null;
var userLists = new Array();
var users = null;

function initialiseLists()
{
  try{
    pageName = getParameter("pageName");
    document.getElementById("pageName").value = pageName;
  }catch(e){}
  try{
    accessType = getParameter("accessType");
    document.getElementById("accessType").value = accessType;
  }catch(e){}

  getLists();
}

function getLists()
{
  pageName = document.getElementById("pageName").value;
  if(pageName=="")
  {
    pageName="/OpenForum/Page"
  }
  document.getElementById("pageName").value = pageName;

  accessType = document.getElementById("accessType").value;
  if(accessType=="")
  {
    accessType="read";
  }
    document.getElementById("accessType").value = accessType;

  //alert("PageName:"+pageName+" AccessType:"+accessType);

  displayUsersList();
  displayGroupsList();
  getAccessRights();

  try{
    inheritedPath = ajax.doGet("/OpenForum/Actions/GetInheritedFilePath","pageName="+pageName+"&fileName=access."+accessType);
  }catch(e){}

  if(inheritedPath!="null" && inheritedPath!=pageName)
  {
document.getElementById('status').innerHTML+="<br/>This pages access rights are definied on the page <a href=\""+inheritedPath+"\">"+inheritedPath+"</a>";
  }
}

function getAccessRights()
{
  if( fileManager.fileExists(pageName,"access."+accessType)==false )
  {
    document.getElementById('status').innerHTML= accessType+" access rights are not defined for page "+pageName;
    if(pageName=="OpenForum/Page")
    {
document.getElementById('status').innerHTML=document.getElementById('status').innerHTML+"<br/>The access rights on this page apply to the whole site.";
    }

    return;
  }
  else
  {
    document.getElementById('status').innerHTML="";
  }

  if(pageName=="OpenForum/Page")
  {  document.getElementById('status').innerHTML=document.getElementById('status').innerHTML+"<br/>The access rights on this page apply to the whole site.";
  }

  data = ajax.doGet( 
    "/OpenForum/Actions/GetXmlFileAsJS",
    "pageName="+pageName+"&fileName=access."+accessType+"&varName=access"
  );

 //alert(data);
  eval(data);
 //alert("count:"+access.children.length);
  for(loopC=0;loopC<access.children.length;loopC++)
  {
    if( access.children[loopC].name=="member" )
    {
      memberName = access.children[loopC].getAttributeValue("name");
      selectMember(memberName);
    }
    else if( access.children[loopC].name=="group" )
    {
      groupName = access.children[loopC].getAttributeValue("name");
 //alert("selecting:"+groupName);
      selectGroup(groupName);
    }
  }
}

function goToPage()
{
  window.location = "/"+pageName;
}

function getSelectedUsers()
{
  userList = new Array();
  userList[0] = new Array();
  userList[1] = new Array();

  for(loopUser=0;loopUser<users.length;loopUser++)
  {
         checked = document.getElementById( users[loopUser][0].replace(' ','_')+"Select" ).checked;    

         if(checked)
         {
            userList[0][ userList[0].length ]= users[loopUser][0];
            userList[1][ userList[1].length ]= users[loopUser][1];
         }
  }

  return userList;
}

function getSelectedGroups()
{
  groupList = new Array();
  groupList[0] = new Array();
  groupList[1] = new Array();

  for(loopGroups=0;loopGroups<groups.length;loopGroups++)
  {
         checked = document.getElementById( groups[loopGroups][0].replace(' ','_')+"Select" ).checked;    

         if(checked)
         {
            groupList[0][ groupList[0].length ]= groups[loopGroups][0];
            groupList[1][ groupList[1].length ]= groups[loopGroups][1];
         }
  }

  return groupList;
}

function selectMember(userName)
{
  for(loop=0;loop<users.length;loop++)
  {
    // alert( userName+"="+users[loop][0]+"?");
    if(users[loop][0]==userName)
    {
         document.getElementById( users[loop][0].replace(' ','_')+"Select" ).checked = true;
         return;      
    }
  }
}

//---- Group functions

function displayUsersList()
{
  data = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName=/Admin/Users&varName=users");
  eval(data);
  
  htmlData = "<table>";
  for(loop=0;loop<users.length;loop++)
  {
    htmlData += "<tr>";

    htmlData += "<td><input type='checkbox' id='"+users[loop][0].replace(' ','_')+"Select' name='"+users[loop][0].replace(' ','_')+"Select'></td>";

    htmlData += "<td><a href='"+users[loop][1]+"'>"+users[loop][0]+"</a></td>";

    htmlData+="<td><a href='' onclick='showUsersGroups(\""+users[loop][0]+"\",\""+users[loop][1]+"\");return false;'><img border='0' src='/OpenForum/Images/icons/gif/group.gif'></a></td>";

    htmlData+="</tr>";

  }
  htmlData += "</table>";

  document.getElementById("users").innerHTML = htmlData;
}

function displayGroupsList()
{
  data = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName=/Admin/Groups&varName=groups");
  eval(data);
 
  htmlData = "<table>";
  for(loop=0;loop<groups.length;loop++)
  {
    htmlData += "<tr>";

    htmlData += "<td><input type='checkbox' id='"+groups[loop][0].replace(' ','_')+"Select' name='"+groups[loop][0].replace(' ','_')+"Select'></td>";

    htmlData += "<td><a href='"+groups[loop][1]+"'>"+groups[loop][0]+"</a></td>";

    htmlData+="<td><a href='' onclick='showGroupsUsers(\""+groups[loop][0]+"\",\""+groups[loop][1]+"\");return false;'><img border='0' src='/OpenForum/Images/icons/gif/user_suit.gif'></a></td>";

    htmlData += "</tr>";

    data = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName="+groups[loop][1]+"&varName=groupUsers");
    eval(data);

   userLists[ groups[loop][0] ] = groupUsers;
   //alert( groups[loop][0]+"="+userLists[ groups[loop][0] ] );
  }
  htmlData += "</table>";

  document.getElementById("groups").innerHTML = htmlData;
}


function showUsersGroups(name,url)
{
  for(loop=0;loop<groups.length;loop++)
  {
     userList = userLists[ groups[loop][0] ];
     document.getElementById( groups[loop][0].replace(' ','_')+"Select" ).checked = false;

     for(loopUser=0;loopUser<userList.length;loopUser++)
     {
       if(userList[loopUser][0]==name)
       {
         document.getElementById( groups[loop][0].replace(' ','_')+"Select" ).checked = true;
         break;
       }
     }
  }
}

function selectGroup(groupName)
{
  for(loop=0;loop<groups.length;loop++)
  {
    // alert( groupName+"="+groups[loop][0]+"?");
   if(groups[loop][0]==groupName)
    {
         document.getElementById( groups[loop][0].replace(' ','_')+"Select" ).checked = true;
         return;      
    }
  }
}

//---- Group functions

function showGroupsUsers(name,url)
{
  for(loopUser=0;loopUser<users.length;loopUser++)
  {
         document.getElementById( users[loopUser][0].replace(' ','_')+"Select" ).checked = false;    
  }

  userList = userLists[ name ];
  for(loopUser=0;loopUser<userList.length;loopUser++)
  {
         document.getElementById( userList[loopUser][0].replace(' ','_')+"Select" ).checked = true;    
  }
}

function saveAccess()
{
  users = getSelectedUsers();
  groups = getSelectedGroups();

  data = "<access>\n"

  for(loop=0;loop<users[0].length;loop++)
  {
    data += "<member name='"+users[0][loop]+"'/>\n";
  }
  for(loop=0;loop<groups[0].length;loop++)
  {
    data += "<group name='"+groups[0][loop]+"'/>\n";
  }

  data += "</access>"

  fileManager.saveFile( pageName,"access."+accessType,data );

  ui.showAlert("Saved",accessType+" access rights saved");
  getLists();
}

function getParameter( name )
{
  name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
  var regexS = "[\\?&]"+name+"=([^&#]*)";
  var regex = new RegExp( regexS );
  var results = regex.exec( window.location.href );
  if( results == null )
    return "";
  else
    return results[1];
}

function deleteAccess()
{
  ajax.doGet("/OpenForum/Actions/Delete","pageName="+pageName+"&fileName=access."+accessType+"&async=true");
  ui.showAlert("Delete",accessType+" access rights deleted");
  getLists();
}