includeLibrary("/OpenForum/Javascript/ui.js");
includeInitFunction( "initialiseAdmin();" )

var groups = null;
var userLists = new Array();
var users = null;

function initialiseAdmin()
{
  displayUsersList();
  displayGroupsList();
}

function getSelectedUsers()
{
  userList = new Array();
  userList[0] = new Array();
  userList[1] = new Array();

  for(loopUser=0;loopUser<users.length;loopUser++)
  {
         checked = document.getElementById( users[loopUser][0].replace(' ','_')+"Select" ).checked;    

//alert( "User:"+users[loopUser][0]+" = "+users[loopUser][0].replace(' ','_')+"Select = "+checked );

         if(checked)
         {
            userList[0][ userList[0].length ]= users[loopUser][0];
            userList[1][ userList[1].length ]= users[loopUser][1];
         }
  }

  return userList;
}

function getSelectedGroups()
{
  groupList = new Array();
  groupList[0] = new Array();
  groupList[1] = new Array();

  for(loopGroups=0;loopGroups<groups.length;loopGroups++)
  {
         checked = document.getElementById( groups[loopGroups][0].replace(' ','_')+"Select" ).checked;    

         if(checked)
         {
            groupList[0][ groupList[0].length ]= groups[loopGroups][0];
            groupList[1][ groupList[1].length ]= groups[loopGroups][1];
         }
  }

  return groupList;
}

function addUsersToGroups()
{
      ui.showMessage("Adding users to Groups","");

  result="";

  userList = getSelectedUsers();
  groupList = getSelectedGroups();

  for(loopGroups=0;loopGroups<groupList[0].length;loopGroups++)
  {
    for(loopUsers=0;loopUsers<userList[0].length;loopUsers++)
    {
      result+="Added "+userList[0][loopUsers]+" to "+groupList[0][loopGroups]+"<BR/>";

addToList(groupList[1][loopGroups],userList[0][loopUsers],userList[1][loopUsers]);
    }
  }
      ui.showAlert("Users added to Groups",result);

  displayGroupsList();
  displayUsersList();
}

function removeUsersFromGroups()
{
      ui.showMessage("Removing users from Groups","");

  userList = getSelectedUsers();
  groupList = getSelectedGroups();

  result="";
  for(loopGroups=0;loopGroups<groupList[0].length;loopGroups++)
  {
    for(loopUsers=0;loopUsers<userList[0].length;loopUsers++)
    {
//alert("Removing "+userList[0][loopUsers]+","+userList[1][loopUsers]+" from "+groupList[1][loopGroups]);
      result+="Removed "+userList[0][loopUsers]+" from "+groupList[0][loopGroups]+"<BR/>";

removeFromList(groupList[1][loopGroups],userList[0][loopUsers],userList[1][loopUsers]);
    }
  }

     ui.showAlert("Users removed from Groups",result);

  displayGroupsList();
  displayUsersList();
}

function displayUsersList()
{
  data = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName=/Admin/Users&varName=users");
  eval(data);
  
  htmlData = "<table>";
  for(loop=0;loop<users.length;loop++)
  {
    htmlData += "<tr>";

    htmlData += "<td><input type='checkbox' id='"+users[loop][0].replace(' ','_')+"Select' name='"+users[loop][0].replace(' ','_')+"Select'></td>";

    htmlData += "<td><a href='"+users[loop][1]+"'>"+users[loop][0]+"</a></td>";

    htmlData+="<td><a href='' onclick='deleteUser(\""+users[loop][0]+"\",\""+users[loop][1]+"\");return false;'><img border='0' src='/OpenForum/Images/icons/gif/cancel.gif'></a></td>";

    htmlData+="<td><a href='' onclick='showUsersGroups(\""+users[loop][0]+"\",\""+users[loop][1]+"\");return false;'><img border='0' src='/OpenForum/Images/icons/gif/group.gif'></a></td>";

    htmlData+="</tr>";

  }
  htmlData += "</table>";

  document.getElementById("users").innerHTML = htmlData;
}

function displayGroupsList()
{
  data = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName=/Admin/Groups&varName=groups");
//alert(data);
  eval(data); 
 
  htmlData = "<table>";
  for(loop=0;loop<groups.length;loop++)
  {
    htmlData += "<tr>";

    htmlData += "<td><input type='checkbox' id='"+groups[loop][0].replace(' ','_')+"Select' name='"+groups[loop][0].replace(' ','_')+"Select'></td>";

    htmlData += "<td><a href='"+groups[loop][1]+"'>"+groups[loop][0]+"</a></td>";

    htmlData += "<td><a href='' onclick='deleteGroup(\""+groups[loop][0]+"\",\""+groups[loop][1]+"\");return false;'><img border='0' src='/OpenForum/Images/icons/gif/cancel.gif'></a></td>";

    htmlData+="<td><a href='' onclick='showGroupsUsers(\""+groups[loop][0]+"\",\""+groups[loop][1]+"\");return false;'><img border='0' src='/OpenForum/Images/icons/gif/user_suit.gif'></a></td>";

    htmlData += "</tr>";

    data = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName="+groups[loop][1]+"&varName=groupUsers");
    eval(data);

   userLists[ groups[loop][0] ] = groupUsers;
   //alert( groups[loop][0]+"="+userLists[ groups[loop][0] ] );
  }
  htmlData += "</table>";

  document.getElementById("groups").innerHTML = htmlData;
}

//---- User functions

function createUser()
{
  ui.showMessage("Creating","User "+document.getElementById("newUserName").value);

newUserPage = "/Admin/Users/"+document.getElementById("newUserName").value;
exists = ajax.doGet("/OpenForum/Actions/PageExists","pageName="+newUserPage);
if(exists=="true")
{
  ui.showConfirm("User Exists","Overwrite User "+document.getElementById("newUserName").value,"_createUser();")
}
else
{
_createUser();
}

}

function _createUser()
{
  ui.showMessage("Creating","User "+document.getElementById("newUserName").value);

newUserPage = "/Admin/Users/"+document.getElementById("newUserName").value;

  data = new Array();
  data[0] = new Array();
  data[1] = new Array();
  data[2] = new Array();

  data[0][0]="newPageName";
  data[0][1]=newUserPage;

  data[1][0]="sourcePageName";
  data[1][1]="/Admin/UserTemplate";

  data[2][0]="listPageName";
  data[2][1]="/Admin/Users";

  ajax.doPost("/OpenForum/Actions/Copy",data);
  displayUsersList();

  ui.showAlert("Created","User "+document.getElementById("newUserName").value);
}

function deleteUser(name,url)
{
  ui.showConfirm("Confirm","Delete User "+name,"_deleteUser(\\\""+name+"\\\",\\\""+url+"\\\");")
}

function _deleteUser(name,url)
{
  ui.showMessage("Deleting","User "+name);

  ajax.doGet("/OpenForum/Actions/Delete","pageName="+url);
  removeFromList( "/Admin/Users",name,url );
  displayUsersList();

  ui.showAlert("Deleted","User "+name);
}

function showUsersGroups(name,url)
{
  for(loop=0;loop<groups.length;loop++)
  {
     userList = userLists[ groups[loop][0] ];
     document.getElementById( groups[loop][0].replace(' ','_')+"Select" ).checked = false;

     for(loopUser=0;loopUser<userList.length;loopUser++)
     {
       if(userList[loopUser][0]==name)
       {
         document.getElementById( groups[loop][0].replace(' ','_')+"Select" ).checked = true;
         break;
       }
     }
  }
}

//---- Group functions

function createGroup()
{
  ui.showMessage("Creating","Group "+document.getElementById("newGroupName").value);

  data = new Array();
  data[0] = new Array();
  data[1] = new Array();
  data[2] = new Array();

  data[0][0]="newPageName";
  data[0][1]="/Admin/Groups/"+document.getElementById("newGroupName").value;

  data[1][0]="sourcePageName";
  data[1][1]="/Admin/GroupTemplate";

  data[2][0]="listPageName";
  data[2][1]="/Admin/Groups";

  ajax.doPost("/OpenForum/Actions/Copy",data);
  displayGroupsList();

  ui.showAlert("Created","Group "+document.getElementById("newGroupName").value);
}

function deleteGroup(name,url)
{
  ui.showConfirm("Confirm","Delete Group "+name,"_deleteGroup(\\\""+name+"\\\",\\\""+url+"\\\");")
}

function _deleteGroup(name,url)
{
  ui.showMessage("Deleting","Group "+document.getElementById("newGroupName").value);

  ajax.doGet("/OpenForum/Actions/Delete","pageName="+url);
  removeFromList( "/Admin/Groups",name,url );
  displayGroupsList();

  ui.showAlert("Deleted","Group "+document.getElementById("newGroupName").value);
}

function showGroupsUsers(name,url)
{
  for(loopUser=0;loopUser<users.length;loopUser++)
  {
         document.getElementById( users[loopUser][0].replace(' ','_')+"Select" ).checked = false;    
  }

  userList = userLists[ name ];
  for(loopUser=0;loopUser<userList.length;loopUser++)
  {
         document.getElementById( userList[loopUser][0].replace(' ','_')+"Select" ).checked = true;    
  }
}

//----- Wiki functions

function addToList(pageName,name,url)
{
e = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName="+pageName+"&varName=data");
//alert("add:"+e);
eval( e );

  newData = "";
  for(loop=0;loop<data.length;loop++)
  {
    if(data[loop][0]==name)
    {
       return;
    }

    newData += "*["+data[loop][0]+"|"+data[loop][1]+"]\r\n";
  }
  newData += "*["+name+"|"+url+"]\r\n";

  fileManager.saveFile(pageName,"page.wiki",newData);
//alert("ADDED:"+newData);
}

function removeFromList(pageName,name,url)
{
e = ajax.doGet("/OpenForum/Actions/GetPageAsList","pageName="+pageName+"&varName=data");
//alert("rem:"+e);
eval( e );

  newData = "";
  found = false;
  for(loop=0;loop<data.length;loop++)
  {
    if(data[loop][0]==name)
    {
       found=true;
// alert("Removing *["+data[loop][0]+"|"+data[loop][1]+"]");
    }
    else
    {
      newData += "*["+data[loop][0]+"|"+data[loop][1]+"]\r\n";
    }
  }

  if(found==true)
  {
    fileManager.saveFile(pageName,"page.wiki",newData);
  }
}

function isValidWikiName(name)
{
 if(name.indexOf("\"")!=-1)
 {
   ui.showAlert("Problem with Name","Please remove double quotes from the name.");
   return false;
 }
 return true;
}