includeLibrary("/OpenForum/Javascript/xml.js");

function DragAndDrop()
{
this.dropTargets = new Array();
this.checkDropTargets = function(dropped)
{
  this.dropFound = false;
  for(this.loop=0;this.loop<this.dropTargets.length;this.loop++)
  {
    if(this.dropTargets[this.loop].deleted==true)
    {
      continue;
    }
    if(this.dropTargets[this.loop]==dropped)
    {
      this.dropTargets[this.loop].clearDrop( dropped );
      continue;
    }

    if(
       dropped.x+dropped.width+(dropped.width/2) > this.dropTargets[this.loop].x && dropped.x+(dropped.width/2) < this.dropTargets[this.loop].x+this.dropTargets[this.loop].width &&
       dropped.y+dropped.height > this.dropTargets[this.loop].y && dropped.y < this.dropTargets[this.loop].y+this.dropTargets[this.loop].height &&
       this.dropFound==false
    )
    {
      if( this.dropTargets[this.loop].checkDrop( dropped )==true )
      {
        this.dropFound = true;
      }
    }
    else
    {
      this.dropTargets[this.loop].clearDrop( dropped );
    }
  }
}

this.processDropTargets = function(dropped)
{
  for(this.loop=0;this.loop<this.dropTargets.length;this.loop++)
  {
    if(this.dropTargets[this.loop].deleted==true)
    {
      continue;
    }
    if(this.dropTargets[this.loop]==dropped)
    {
      continue;
    }

    if(
       dropped.x+dropped.width+(dropped.width/2) > this.dropTargets[this.loop].x && dropped.x+(dropped.width/2) < this.dropTargets[this.loop].x+this.dropTargets[this.loop].width &&
       dropped.y+dropped.height > this.dropTargets[this.loop].y && dropped.y < this.dropTargets[this.loop].y+this.dropTargets[this.loop].height
    )
    {
      //alert( dropped.objName+" dropped on "+dropTargets[loop].objName );
      this.dropTargets[this.loop].processDrop( dropped );
      break;
    }
  }
}

}

var dragAndDrop = new DragAndDrop();

function DragAndDropObject(objName)
{
  dragAndDrop.dropTargets[ dragAndDrop.dropTargets.length ] = this;

  this.deleted = false;
  this.objName = objName;

  this.objLayer = document.getElementById( this.objName );

  this.width = this.objLayer.offsetWidth;
  this.height = this.objLayer.offsetHeight;
 
  pos = ui.findLayerPosition( this.objLayer )
  this.x = pos[0]+(this.width/2);
  this.y = pos[1]+(this.height/2);

  this.selected = false;

  this.pickUp = function()
  {
    this.selected = true;
    this.objLayer.style.zIndex=110;
    this.objLayer.style.opacity=0.7;
  }

  this.drag = function(x,y)
  {
    this.objLayer = document.getElementById( this.objName );
    this.x = x-(this.width/2);
    this.y = y-(this.height/2);

    this.setPosition(this.x,this.y);

    this.objLayer.style.left = this.x;
    this.objLayer.style.top = this.y;

    for(loop=0;loop<this.attached.length;loop++)
    {
      eval( this.attached[loop].dragMethod+"( "+x+","+y+" );",this.attached[loop].attachObject );
    }
    dragAndDrop.checkDropTargets( this );
  }

  this.setPosition = function(x,y)
  {
    this.x =x;//+(this.width/2);
    this.y =y;//+(this.height/2);

    this.objLayer.style.left = this.x;
    this.objLayer.style.top = this.y;

    for(loop=0;loop<this.attached.length;loop++)
    {
      eval( this.attached[loop].dragMethod+"( "+this.x+","+this.y+" );",this.attached[loop].attachObject );
    }
  }

  this.isSticky = function(){ return false; }

  this.drop = function()
  {
    this.objLayer.style.zIndex=100;
    this.objLayer.style.opacity=1.0;
    dragAndDrop.processDropTargets( this );
  }

  this.rightClick = function(){}

  this.attached = new Array();
  this.attach = function(attachObject,dragMethod)
  {
    for(loop=0;loop<this.attached.length;loop++)
    {
      if(this.attached[loop].attachObject==attachObject)
      {
        return;
      }
    }

    this.attached[ this.attached.length ] = new Attachment(attachObject,dragMethod);

      eval( dragMethod+"( "+this.x+","+this.y+" );",attachObject );
  }

  this.detatch = function(attachObject)
  {
    newAttached = new Array();
    for(loop=0;loop<this.attached.length;loop++)
    {
      if(this.attached[loop].attachObject!=attachObject)
      {
        newAttached[newAttached.length] = this.attached[loop]
      }
    }
    this.attached = newAttached;
  }

  this.checkDrop = function(dropped){return false;}
  this.clearDrop = function(dropped){}

  this.processDrop = function(dropped){}

  metaData = new XmlElement("data");
}

function Attachment(attachObject,dragMethod)
{
  this.attachObject = attachObject;
  this.dragMethod= dragMethod;
}