package org.one.stone.soup.file;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

 /**
	* The Progress Listener interface is implemented by a class that
	* needs to be informed of the progress of a thread. The class
	* could be a visual component that informs a user of a tasks
	* progress.
	*
*/

public interface ProgressListener {
/**
 *
 */
void finished();
/**
 *
 */
void message(String message);
/**
 *
 * @param poisition long
 * @param end long
 */
void progress(long poisition, long end);
}
