package org.one.stone.soup.reloader;

public abstract class ReloadListener {

	public abstract boolean codeHasChangedReload();
	
	private static ReloadListener reloadListener = null;
	
	public static void setReloadListener(ReloadListener newReloadListener)
	{
		if(reloadListener==null)
		{
			reloadListener = newReloadListener;
			System.out.println("New Reloader set "+newReloadListener);
		}
		else
		{
			System.out.println("Reloader already set as "+reloadListener);
		}
	}
	public static ReloadListener getReloadListener()
	{
		return reloadListener;
	}
}
