package org.one.stone.soup.util;

import java.util.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.co.uk/pages/licence-os.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class VectorHelper {
	
public static Vector getHashtableAsVector(Hashtable table)
{
	// Keep latest version
	Enumeration keys = table.keys();
	Vector list = new Vector();
	
	while( keys.hasMoreElements() )
	{
		list.addElement(table.get(keys.nextElement()));
		//list.addElement(keys.nextElement());
	}
	
	return list;
}

public static void copy(Vector a,int offsetA,Vector b,int offsetB)
{
	for(int loop=offsetA;loop<a.size();loop++)
	{
		int indexB = (loop-offsetA)+offsetB;
		if(b.size()<=indexB)
		{
			b.addElement(a.elementAt(loop));
		}
		else
		{
			b.setElementAt( a.elementAt(loop),indexB );
		}
	}
}

public static Vector getHashtableKeysAsVector(Hashtable table)
{
	Vector list = new Vector();
	
	list.addAll( table.keySet() );
	
	return list;
}

}
