newPageName = extension.getAttributeValueByName("pageName");
firstFileName = extension.getAttributeValueByName("fileName");

if(newPageName!=null)
{
  pageName = newPageName;
}
while(pageName.charAt(0)=='/')
{
  pageName = pageName.substring(1);
}

page = "<DIV class='imageBar'><table><tr>";

files = file.getAttachmentsForPage(pageName);
fileNames = files.keys();
while(fileNames.hasMoreElements())
{
  fileName = fileNames.nextElement();
  
  if(fileName.charAt(0)=='+')
  {
    continue;
  }
  if(fileName.indexOf(".thumbnail.")!=-1)
  {
    continue;
  }
  if(fileName.indexOf(".icon.")!=-1)
  {
    continue;
  }
  
  if(file.isImageAttachment(fileName))
  {
    filePath = files.get(fileName);
    if(firstFileName==null)
    {
      firstFileName = pageName+"\",\""+fileName;
    }    

    parts = new String(fileName).split(".");
    thumbnail = parts[0]+".thumbnail.png";
    //thumbnail = fileName+".thumbnail.png";
    
    imageToShow = filePath;
    if( file.attachmentExists(pageName,thumbnail) )
    {
      imageToShow = pageName+"/"+thumbnail;
      page += "<td><a href='' onClick='showPhoto(\""+pageName+"\",\""+fileName+"\",false);return false;'><img src='/"+imageToShow+"' alt='"+fileName+"' title='"+fileName+"' class='imageBox'></a></td>";
    }
    else
    {
      page += "<td><a href='' onClick='showPhoto(\""+pageName+"\",\""+fileName+"\",false);return false;'><img width='200' height='100' src='/"+imageToShow+"' alt='"+fileName+"' title='"+fileName+"' class='imageBox'></a></td>";
    }
    
  }
}
page += "</tr></table></DIV>";

page += "<br/><center><DIV id='mainImage'></DIV></center>";

page += "<script>includeLibrary('/OpenForum/Extensions/PhotoAlbum/photos.js');includeInitFunction('showPhoto(\""+firstFileName+"\",false)');</script>"

return page;