select = transaction.getParameter("Select");
from = transaction.getParameter("From");
pageSize = transaction.getParameter("PageSize");
pageNumber = transaction.getParameter("PageNumber");

if(select==null)
{
  transaction.setResult(transaction.SHOW_PAGE);
}
else
{
  dbName = transaction.getParameter("db");
  db = js.getApi("/OpenForum/JarManager/JDBC");

  if(pageNumber==null)
  {
    pageNumber = 0;
  }

try{
   result = db.doPagedQuery(dbName,select,from,pageSize,pageNumber);
}
catch(e)
{
  transaction.sendPage(e);
}
    data = "";
    columns = Number(result.getAttributeValueByName("columns"));

    xColumns = result.getElementByName("columns");
    for(column=0;column<columns;column++)
    {
      data+="|__"+xColumns.getElementByIndex(column).getValue().replace("#"," Number")+"__";
    }
    data+="\n";

    rows = result.getElementsByName("row");
    for(row=0;row<rows.size();row++)
    {
      for(column=0;column<columns;column++)
      {
        data+="|"+rows.elementAt(row).getElementByIndex(column).getValue();
      }
      data+="\n";
    }
  pagesAvailable = new Number(result.getAttributeValueByName("pagesAvailable"));
  pageNumber = new Number(pageNumber);

  data += "Page "+(pageNumber+1)+" of "+(pagesAvailable+1);

  page = wiki.renderWikiData( "Result",data );
  
  layerName = transaction.getParameter("layer");

if(pageNumber>0)
  {
    page += "<a href='' onClick='";

    page += "resultHtml = ajax.doGet(";

    page+="\"/OpenForum/JarManager/JDBC/PagedQuery\",";

    page+="\"Select="+select;
    page+="&From="+from;
    page+="&db="+dbName;
    page+="&PageSize="+pageSize;
    page+="&PageNumber="+(pageNumber-1);
    page+="&layer="+layerName;

    page+="\");";
    page += "document.getElementById(\""+layerName+"\").innerHTML = resultHtml;"
    page += "return false;"

    page += "'/><<</a>";
  }
if(pageNumber<pagesAvailable)
  {
    page += "<a href='' onClick='";

    page += "resultHtml = ajax.doGet(";

    page+="\"/OpenForum/JarManager/JDBC/PagedQuery\",";

    page+="\"Select="+select;
    page+="&From="+from;
    page+="&db="+dbName;
    page+="&PageSize="+pageSize;
    page+="&PageNumber="+(pageNumber+1);
    page+="&layer="+layerName;

    page+="\");";
    page += "document.getElementById(\""+layerName+"\").innerHTML = resultHtml;"
    page += "return false;"

    page += "'/>>></a>";
  }


  transaction.sendPage(page);
}