lineIndex = 0;
lines = new Array();

  function Line(x,y,w,h)
  {
  	this.mode=null;
  	this.layerId = "line"+lineIndex;
  	lineIndex++;
	lines[this.layerId] = this;

  	this.getSource = function()
	  {
		var source = "<div id='"+this.layerId+".x' style='position:absolute; top:"+(this.yi+this.xyOffset)+"; left:"+this.xi+"; z-index: 1;'><img id='"+this.layerId+".wImg' src='/OpenForum/Javascript/DragAndDrop/dot.PNG' width='"+this.xWidth+"' height='2'/></div>";

		source += "<div id='"+this.layerId+".y' style='position:absolute; top:"+this.yi+"; left:"+(this.xi+this.yxOffset)+";z-index: 1;'><img id='"+this.layerId+".hImg' src='/OpenForum/Javascript/DragAndDrop/dot.PNG' width='2' height='"+this.yHeight+"'/></div>";
		return source;
	  }
	  
  	this.setPosition = function(x,y)
	  {
		this.x = x;
		this.y = y;
		this.convertPosition();

		var xLayer = document.getElementById(this.layerId+".x");
		xLayer.style.left = this.xi;
		xLayer.style.top = this.yi+this.xyOffset;
		document.getElementById(this.layerId+".wImg").width=this.xWidth;

		var yLayer = document.getElementById(this.layerId+".y");
		yLayer.style.left = this.xi+this.yxOffset;
		yLayer.style.top = this.yi;
		document.getElementById(this.layerId+".hImg").height=this.yHeight;
	  }
	  
  	this.setStart = function(x,y)
	  {
		dx = x-this.x;
		dy = y-this.y;

		this.w-=dx;
		this.h-=dy;
		this.x+=dx;
		this.y+=dy;

		this.setPosition(this.x,this.y);
	  }
	  
  	this.setEnd = function(x,y)
	  {
		this.w = x-this.x;
		this.h = y-this.y;

		this.setPosition(this.x,this.y);
	  }

  	this.convertPosition = function()
	  {
		this.xi = this.x;
		this.yi = this.y;

		this.xWidth = this.w;
		this.yxOffset = this.w;

		if(this.w<0)
		{
			this.xi=this.x+this.w;
			this.xWidth = this.w*-1;
			this.yxOffset = 0;
		}

		if(this.h<0)
		{
			this.yi=this.y+this.h;
			this.yHeight = this.h*-1;
			this.xyOffset = (this.h*-1)-2;
		}
		else
		{
			this.xyOffset = 0;
			this.yHeight = this.h;
		}
	  }

  	this.x = x;
  	this.y = y;
  	this.w = w;
  	this.h = h;
	this.convertPosition();

  	var canvas = document.getElementById("canvas");
  	canvas.innerHTML=canvas.innerHTML+this.getSource();

  }

  function Arrow(x,y,w,h)
  {
  	this.mode=null;
  	this.layerId = "line"+lineIndex;
  	lineIndex++;
	lines[this.layerId] = this;

  	this.getSource = function()
	  {
		var source = "<div id='"+this.layerId+".x' style='position:absolute; top:"+(this.yi+this.xyOffset)+"; left:"+this.xi+"; z-index: 1;'><img id='"+this.layerId+".wImg' src='/OpenForum/Javascript/DragAndDrop/dot.PNG' width='"+this.xWidth+"' height='2'/></div>";

		source += "<div id='"+this.layerId+".y' style='position:absolute; top:"+this.yi+"; left:"+(this.xi+this.yxOffset)+";z-index: 1;'><img id='"+this.layerId+".hImg' src='/OpenForum/Javascript/DragAndDrop/dot.PNG' width='2' height='"+this.yHeight+"'/></div>";

		source += "<div id='"+this.layerId+".x.arrow' style='position:absolute; top:"+(this.yi+this.xyOffset)+"; left:"+this.xi+"; z-index: 1;'><img id='"+this.layerId+".x.arrowImg' src='/OpenForum/Javascript/DragAndDrop/up-arrow.PNG'/></div>";

		source += "<div id='"+this.layerId+".y.arrow' style='position:absolute; top:"+this.yi+"; left:"+(this.xi+this.yxOffset)+";z-index: 1;'><img id='"+this.layerId+".y.arrowImg' src='/OpenForum/Javascript/DragAndDrop/right-arrow.PNG'/></div>";

		return source;
	  }
	  
  	this.setPosition = function(x,y)
	  {
		this.x = x;
		this.y = y;
		this.convertPosition();

		var xLayer = document.getElementById(this.layerId+".x");
		xLayer.style.left = this.xi;
		xLayer.style.top = this.yi+this.xyOffset;
		document.getElementById(this.layerId+".wImg").width=this.xWidth;

		var yLayer = document.getElementById(this.layerId+".y");
		yLayer.style.left = this.xi+this.yxOffset;
		yLayer.style.top = this.yi;
		document.getElementById(this.layerId+".hImg").height=this.yHeight;

		var xArrow = document.getElementById(this.layerId+".x.arrow");
		xArrow.style.top = this.y+(this.h/2);
		xArrow.style.left = this.x+this.w-7;

		if(this.xyOffset==0)
		{
document.getElementById(this.layerId+".x.arrowImg").src="/OpenForum/Javascript/DragAndDrop/down-arrow.png";
		}
		else
		{
document.getElementById(this.layerId+".x.arrowImg").src="/OpenForum/Javascript/DragAndDrop/up-arrow.png";	
		}

		if(this.yxOffset==0)
		{
document.getElementById(this.layerId+".y.arrowImg").src="/OpenForum/Javascript/DragAndDrop/left-arrow.png";
		}
		else
		{
document.getElementById(this.layerId+".y.arrowImg").src="/OpenForum/Javascript/DragAndDrop/right-arrow.png";	
		}

		var yArrow = document.getElementById(this.layerId+".y.arrow");
		yArrow.style.top = this.y-9;
		yArrow.style.left = this.x+(this.w/2);

	  }
	  
  	this.setStart = function(x,y)
	  {
		dx = x-this.x;
		dy = y-this.y;

		this.w-=dx;
		this.h-=dy;
		this.x+=dx;
		this.y+=dy;

		this.setPosition(this.x,this.y);
	  }
	  
  	this.setEnd = function(x,y)
	  {
		this.w = x-this.x;
		this.h = y-this.y;

		this.setPosition(this.x,this.y);
	  }

  	this.convertPosition = function()
	  {
		this.xi = this.x;
		this.yi = this.y;

		this.xWidth = this.w;
		this.yxOffset = this.w;

		if(this.w<0)
		{
			this.xi=this.x+this.w;
			this.xWidth = this.w*-1;
			this.yxOffset = 0;
		}

		if(this.h<0)
		{
			this.yi=this.y+this.h;
			this.yHeight = this.h*-1;
			this.xyOffset = (this.h*-1)-2;
		}
		else
		{
			this.xyOffset = 0;
			this.yHeight = this.h;
		}
	  }

  	this.x = x;
  	this.y = y;
  	this.w = w;
  	this.h = h;
	this.convertPosition();

  	var canvas = document.getElementById("canvas");
  	canvas.innerHTML=canvas.innerHTML+this.getSource();

  }