package org.one.stone.soup.file;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

 /**
	* The FileChangeListener is implemented by any class that needs to
	* be informed of file changes by an instance of FileWatch.
	* The class will have its implementation of the fileChanged method
	* called with the instance of the File that has changed.
	*
*/

public interface FileChangeListener {
/**
 *
 * @param file the file that has changed
 */
void fileChanged(java.io.File file);
}
