package org.one.stone.soup.wiki.upload.applet;

import java.awt.Component;

import javax.swing.JApplet;
import javax.swing.JProgressBar;

public class UploadApplet extends JApplet {
	
	private AppletDropReceiver receiver = null;
	private JProgressBar progressBar = null;
	public UploadApplet()
	{
		super();
		progressBar = new JProgressBar();
		add(progressBar);
		Uploader.getUploader().setProgressBar(progressBar);
		
		receiver = new AppletDropReceiver((Component)progressBar,this);
	}
	
	public void start()
	{
		System.out.println("Started build 0019");
	}
   
   public void receiveFileList(String[] fileList)
   {
	   for(int loop=0;loop<fileList.length;loop++)
	   {
		   System.out.println(loop+" = "+fileList[loop]);
		   Uploader.getUploader().upload( getDocumentBase(),fileList[loop] );
	   }
  }
   
   public void setAuthentication(String authentication)
   {
	   Uploader.getUploader().setAuthentication(authentication);
   }
}
